# Twentieth International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
on how to compile it and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details (this
year we included most of the information by the submitters).

Some ANSI C compilers are not quite as good as they should be.  If
yours is lacking, you may need to compile using gcc instead of your
local compiler.


### Historical note:

The IOCCC has a website and now has a number of international mirrors.
The primary website can be found at [www.ioccc.org](https://www.ioccc.org).


### Historical update:

The IOCCC website once had a number of
[international mirrors](https://web.archive.org/web/20201030210517/https://www.ioccc.org/mirror.html).
As of 2020 Dec 29, [GitHub](https://www.github.com) serves as the distributed server farm for the
[IOCCC winner repo](https://github.com/ioccc-src/winner) that GitHub renders as
[Official IOCCC website - www.ioccc.org](https://www.ioccc.org).


## Remarks on some of the entries

There were some outstanding entries that did not win.  Unfortunately
some very good entries lost because they:

+ did not follow the "one program - one file" rule;

+ depended too much on 32 bit architectures;

+ were more of the "obfuscated math" kind rather than the "obfuscated C" kind.

We hope the authors of some of those entries will fix and re-submit
them for the next IOCCC.

We believe you will be impressed with this year's winning entries. The [Best of
Show - Most Shrinkable](akari/index.html) is a fine example of character
stitching.  But don't ignore the other entries!  There are games, puzzle
solvers, utilities, eye candy, calculators and graphical and audio tools.

This year all authors are different, and there is a authors from a new country -
[China](../location.html#CN)!  Many authors won for the first time. (Please
note that judging is done completely anonymously.  Be warned that we may
disqualify entries that reveal the identity of the submitter).


## Final Comments

**IMPORTANT NOTE**: See [contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also the [IOCCC FAQ](../faq.html) for additional information on the IOCCC.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

        Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

        https://creativecommons.org/licenses/by-sa/4.0/

-->
